﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;
using System.Drawing.Drawing2D;
    
namespace FormsApp
{
    public partial class Form1 : Form
    {
        [STAThread]
        static void Main()
        {
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            Application.Run(new Form1());
        }
    
        public Form1()
        {
            InitializeComponent();
    
            this.Icon = Resources.Resource1.Icon1;
        }
    
        // Рисование головки Буратино
        private void DrawBuratino()
        {
            GraphicsPath path = new GraphicsPath();
            path.AddArc(20, 20, 120, 120, 0, 330);  // Голова без носа
            path.AddArc(220, 20, 10, 10, 270, 180); // Удаленный кончик носа
            path.CloseFigure();                     // Замкнули незаконченные дуги
            path.AddEllipse(90, 40, 20, 20);        // Добавили глаз
    
            Graphics gr = this.CreateGraphics();  // Создаем холст
            gr.DrawPath(Pens.Red, path);          // Рисуем контур Буратино
            gr.TranslateTransform(200, 0);        // Смещаемся вправо
            gr.FillPath(Brushes.Blue, path);      // Рисуем заливку Буратино
            gr.DrawPath(Pens.Red, path);          // Рисуем контур для заливки
        }
    
        // Переопределяем метод перерисовки формы 
        protected override void OnPaint(PaintEventArgs e)
        {
            DrawBuratino();
            DrawForm();
            base.OnPaint(e);
        }
    
        // Рисование непрямоугольной формы
        private void DrawForm()
        {
            GraphicsPath path = new GraphicsPath();
            path.AddEllipse(0, -300, this.Width, 600);
            this.Region = new Region(path);
        }
    
        private void Form1_Resize(object sender, EventArgs e)
        {
            this.Invalidate();
        }
    
        int x, y;

        private void Form1_MouseDown(object sender, MouseEventArgs e)
        {
            // Сохраняем координаты мыши на момент щелчка относительно формы
            if (e.Button == MouseButtons.Left)
            {
                x = e.X;
                y = e.Y;
    
                // Форма курсора 
                Cursor.Current = Cursors.SizeAll;
            }
        }
    
        private void Form1_MouseMove(object sender, MouseEventArgs e)
        {
            // Измеряем смещение относительно щелчка
            // и подвигаем форму на это смещение
            if (e.Button == MouseButtons.Left)
            {
                this.Left += e.X - x;
                this.Top += e.Y - y;
            }
        }
    }
}