using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;
using System.IO;
    
using System.Reflection;
    
namespace FormsApp
{
    partial class StandardDialogs
    {
        #region  ColorDialog
    
        //     
        int[] customColors = new int[16]
            {
                0xFFFFFF,0xFFFFFF,0xFFFFFF,0xFFFFFF,
                0xFFFFFF,0xFFFFFF,0xFFFFFF,0xFFFFFF,
                0xFFFFFF,0xFFFFFF,0xFFFFFF,0xFFFFFF,
                0xFFFFFF,0xFFFFFF,0xFFFFFF,0xFFFFFF
            };
    
        private void btnShowColorDialog_Click(object sender, EventArgs e)
        {
            //     
            ColorDialog dlg = new ColorDialog();
    
            //   
            dlg.CustomColors = customColors;
            foreach (Control ctrl in this.tabPage4.Controls)
            {
                //      
                if (ctrl is CheckBox)
                {
                    //    
                    switch (ctrl.Name.ToString())
                    {
                        case "AllowFullOpen":
                            dlg.AllowFullOpen = ((CheckBox)ctrl).Checked;
                            break;
                        case "AnyColor":
                            dlg.AnyColor = ((CheckBox)ctrl).Checked;
                            break;
                        case "FullOpen":
                            dlg.FullOpen = ((CheckBox)ctrl).Checked;
                            break;
                        case "SolidColorOnly":
                            dlg.SolidColorOnly = ((CheckBox)ctrl).Checked;
                            break;
                        case "ShowHelp":
                            dlg.ShowHelp = ((CheckBox)ctrl).Checked;
                            break;
                    }
                }
            }
    
            //   
            dlg.Color = panelColorDialog.BackColor;
    
            //     
            //    
            if (dlg.ShowDialog() == DialogResult.OK)
            {
                panelColorDialog.BackColor = dlg.Color;
                lblColorName.Text = dlg.Color.Name;
    
                //    
                customColors = dlg.CustomColors;
            }
        }
    
        private void btnResetColorDialog_Click(object sender, EventArgs e)
        {
            //      
            ColorDialog dlg = colorDialog;
    
            //  
            dlg.Reset();
    
            //        
            //      
            PropertyInfo[] props = 
                typeof(ColorDialog).GetProperties();//   
            //   
            foreach (PropertyInfo prop in props)
            {
                //    
                if (prop.PropertyType == typeof(bool))
                {
                    //   -   
                    //        
                    Control[] controls = this.Controls.Find(prop.Name, true);
    
                    //      
                    ((CheckBox)controls[0]).Checked =
                        (bool)prop.GetGetMethod().Invoke(dlg, null);
                }
            }
    
            //   
            panelColorDialog.BackColor = dlg.Color;
            lblColorName.Text = dlg.Color.Name;
        }
    
        #endregion
    }
}