using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;
using System.IO;

namespace FormsApp
{
    partial class StandardDialogs
    {

        #region  MessageBox
        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            //     groupBox1
            //  ,   ,  
            foreach (Control box in groupBox1.Controls)
            {
                String type = box.GetType().ToString();
                //     
                type = type.Substring(type.LastIndexOf('.') + 1);
                if (type == "Label")
                    continue;
                else
                    box.Enabled = false;
            }

            //    
            //   
            switch (comboBox1.SelectedIndex + 1)
            {
                case 6:
                    comboBox5.Enabled = true;
                    goto case 5;
                case 5:
                    comboBox4.Enabled = true;
                    goto case 4;
                case 4:
                    comboBox3.Enabled = true;
                    goto case 3;
                case 3:
                    comboBox2.Enabled = true;
                    goto case 2;
                case 2:
                    textBox2.Enabled = true;
                    goto case 1;
                case 1:
                    textBox1.Enabled = true;
                    break;
            }
        }

        private void btnShow_Click(object sender, EventArgs e)
        {
            // ,   
            if (comboBox1.Text == "")
            {
                MessageBox.Show("   Show()");
                return;
            }

            // ,    
            foreach (Control box in groupBox1.Controls)
            {
                String type = box.GetType().ToString();
                type = type.Substring(type.LastIndexOf('.') + 1);
                //      
                if (type == "Label" || box.Enabled == false)
                    continue;
                //    ,  
                else if (box.Text.Trim().Length <= 0)
                {
                    MessageBox.Show("   ");
                    return;
                }
            }

            //     
            MessageBoxButtons[] buttons = {
                MessageBoxButtons.AbortRetryIgnore,
                MessageBoxButtons.OK, 
                MessageBoxButtons.OKCancel, 
                MessageBoxButtons.RetryCancel,
                MessageBoxButtons.YesNo, 
                MessageBoxButtons.YesNoCancel
            };

            MessageBoxIcon[] icon = {
                MessageBoxIcon.Asterisk,
                MessageBoxIcon.Error,
                MessageBoxIcon.Exclamation,
                MessageBoxIcon.Hand,
                MessageBoxIcon.Information,
                MessageBoxIcon.None,
                MessageBoxIcon.Question,
                MessageBoxIcon.Stop,
                MessageBoxIcon.Warning	
            };

            MessageBoxDefaultButton[] defaultButton = {
                MessageBoxDefaultButton.Button1,
                MessageBoxDefaultButton.Button2,
                MessageBoxDefaultButton.Button3
            };

            MessageBoxOptions[] options = {
                MessageBoxOptions.DefaultDesktopOnly,
                MessageBoxOptions.RightAlign,
                MessageBoxOptions.RtlReading,
                MessageBoxOptions.ServiceNotification
            };

            //      
            try
            {
                switch (comboBox1.SelectedIndex)
                {
                    case 0:
                        MessageBox.Show(textBox1.Text);
                        break;
                    case 1:
                        MessageBox.Show(textBox1.Text, textBox2.Text);
                        break;
                    case 2:
                        MessageBox.Show(textBox1.Text, textBox2.Text,
                            buttons[comboBox2.SelectedIndex]);
                        break;
                    case 3:
                        MessageBox.Show(textBox1.Text, textBox2.Text,
                            buttons[comboBox2.SelectedIndex],
                            icon[comboBox3.SelectedIndex]);
                        break;
                    case 4:
                        MessageBox.Show(textBox1.Text, textBox2.Text,
                            buttons[comboBox2.SelectedIndex],
                            icon[comboBox3.SelectedIndex],
                            defaultButton[comboBox4.SelectedIndex]);
                        break;
                    case 5:
                        MessageBox.Show(textBox1.Text, textBox2.Text,
                            buttons[comboBox2.SelectedIndex],
                            icon[comboBox3.SelectedIndex],
                            defaultButton[comboBox4.SelectedIndex],
                            options[comboBox5.SelectedIndex]);
                        break;
                }
            }
            catch (System.Exception exc)
            {
                MessageBox.Show("   !"
                    + Environment.NewLine
                    + exc.Message,
                    "",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Stop);
            }
        }

        //     
        private void lockBox_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = true;
        }
        #endregion

    }
}