using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;
using System.IO;

namespace FormsApp
{
    partial class StandardDialogs
    {

        #region  SaveFileDialog

        private void btnBrowseFileName_Click(object sender, EventArgs e)
        {
            openFileDialog.CheckFileExists = false;
            openFileDialog.CheckPathExists = false;
            openFileDialog.ShowDialog();
            String str = openFileDialog.FileName;
            txtFileName.Text = str;
            txtInitialDirectory.Text = Path.GetDirectoryName(str);
        }

        private void btnShowDialog_Click(object sender, EventArgs e)
        {
            CheckToSaveFileDialog();    //  
            saveFileDialog.ShowDialog();//  
            SaveFileDialogToCheck();    //  
        }

        private void btnReset_Click(object sender, EventArgs e)
        {
            //    
            //     
            saveFileDialog.Reset();
            SaveFileDialogToCheck();
        }

        void CheckToSaveFileDialog()
        {
            //    NumericUpDown
            filterIndex.Minimum = 1;
            filterIndex.Maximum = txtFilter.Text.Split('|').Length / 2;

            //   
            saveFileDialog.AddExtension =
                checkedListBox.GetItemChecked(
                checkedListBox.Items.IndexOf("AddExtension"));
            saveFileDialog.CheckFileExists =
                    checkedListBox.GetItemChecked(
                    checkedListBox.Items.IndexOf("CheckFileExists"));
            saveFileDialog.CheckPathExists =
                    checkedListBox.GetItemChecked(
                    checkedListBox.Items.IndexOf("CheckPathExists"));
            saveFileDialog.DereferenceLinks =
                    checkedListBox.GetItemChecked(
                    checkedListBox.Items.IndexOf("DereferenceLinks"));
            saveFileDialog.RestoreDirectory =
                    checkedListBox.GetItemChecked(
                    checkedListBox.Items.IndexOf("RestoreDirectory"));
            saveFileDialog.ShowHelp =
                    checkedListBox.GetItemChecked(
                    checkedListBox.Items.IndexOf("ShowHelp"));
            saveFileDialog.ValidateNames =
                    checkedListBox.GetItemChecked(
                    checkedListBox.Items.IndexOf("ValidateNames"));
            saveFileDialog.CreatePrompt =
                    checkedListBox.GetItemChecked(
                    checkedListBox.Items.IndexOf("CreatePrompt"));
            saveFileDialog.OverwritePrompt =
                    checkedListBox.GetItemChecked(
                    checkedListBox.Items.IndexOf("OverwritePrompt"));

            //     
            saveFileDialog.DefaultExt = txtDefaultExt.Text;
            saveFileDialog.FileName = txtFileName.Text;
            saveFileDialog.Filter = txtFilter.Text;
            saveFileDialog.FilterIndex = (int)filterIndex.Value;
            saveFileDialog.InitialDirectory = txtInitialDirectory.Text;
            saveFileDialog.Title = txtTitle.Text;
        }

        void SaveFileDialogToCheck()
        {
            //    
            //    
            checkedListBox.SetItemChecked(
                checkedListBox.Items.IndexOf("AddExtension"),
                saveFileDialog.AddExtension);
            checkedListBox.SetItemChecked(
                checkedListBox.Items.IndexOf("CheckFileExists"),
                saveFileDialog.CheckFileExists);
            checkedListBox.SetItemChecked(
                checkedListBox.Items.IndexOf("CheckPathExists"),
                saveFileDialog.CheckPathExists);
            checkedListBox.SetItemChecked(
                checkedListBox.Items.IndexOf("DereferenceLinks"),
                saveFileDialog.DereferenceLinks);
            checkedListBox.SetItemChecked(
                checkedListBox.Items.IndexOf("RestoreDirectory"),
                saveFileDialog.RestoreDirectory);
            checkedListBox.SetItemChecked(
                checkedListBox.Items.IndexOf("ShowHelp"),
                saveFileDialog.ShowHelp);
            checkedListBox.SetItemChecked(
                checkedListBox.Items.IndexOf("ValidateNames"),
                saveFileDialog.ValidateNames);
            checkedListBox.SetItemChecked(
                checkedListBox.Items.IndexOf("CreatePrompt"),
                saveFileDialog.CreatePrompt);
            checkedListBox.SetItemChecked(
                checkedListBox.Items.IndexOf("OverwritePrompt"),
                saveFileDialog.OverwritePrompt);

            //    ,     
            // txtDefaultExt.Text = saveFileDialog.DefaultExt;
            txtFileName.Text = saveFileDialog.FileName;
            // txtFilter.Text = saveFileDialog.Filter;
            // filterIndex.Value = saveFileDialog.FilterIndex;
            // txtInitialDirectory.Text = saveFileDialog.InitialDirectory;
            // txtTitle.Text = saveFileDialog.Title;
        }

        #endregion

    }
}